; ============================================================================
#define segment_code  .text
#define segment_data  .data
#define segment_bss   .bss 
#define wrd           .word
#define byt           .byt

; ============================================================================
segment_code

#define fdc_base                      $310
#define fdc_command_register          fdc_base+0
#define fdc_status_register           fdc_base+0
#define fdc_track_register            fdc_base+1
#define fdc_sector_register           fdc_base+2
#define fdc_data                      fdc_base+3
#define fdc_flags                     fdc_base+4
#define fdc_drq                       fdc_base+8

#define cmd_restore                   $0b
#define cmd_seek                      $1f
#define cmd_stepin                    $5f
#define cmd_stepout                   $7f
#define cmd_readsector                $82
#define cmd_writesector               $a2
#define cmd_forceinterrupt            $d0

#define fdc_flag_discside             %00010000
#define fdc_flags_mask                %10000100


#if 1
#define ralign(r)                     .dsb ((r&3)-((*+3)&3))&3,$ea
#else
#define ralign(r)
#endif


; ----------------------------------------------------------------------------
*             =       START_ADDRESS

; ----------------------------------------------------------------------------
_main:
              ldy     #0
msg_loop
              lda     drv_msg,y
              tax
              beq     msg_end
              jsr     $0238
              iny
              bne     msg_loop
msg_end

getch
              jsr     $023b
              bpl     getch
              
              and     #$7f
              cmp     #'A'
              beq     d_ok
              cmp     #'B'
              beq     d_ok
              cmp     #'C'
              beq     d_ok
              cmp     #'D'
              beq     d_ok
              bne     getch

d_ok
              tax
              jsr     $0238
              ldx     #$0d
              jsr     $0238
              ldx     #$0a
              jsr     $0238

              sec
              sbc     #'A'
              tax
              
              php
              sei
              
              ralign(fdc_flags)
              lda     fdc_flags
              sta     flags_save

              and     #%10011111
              ora     drv_tab,x
              ralign(fdc_flags)
              sta     fdc_flags
   
              lda     #cmd_restore
              
              ralign(fdc_command_register)
              sta     fdc_command_register
              jsr     wait_completion

              
              lda     flags_save
              ralign(fdc_flags)
              sta     fdc_flags

              plp
              rts

; ----------------------------------------------------------------------------
; X,Y - unchanged
; Y = fdc_offset
wait_completion
              txa
              ldx     #5
wc_0
              dex
              bne     wc_0
              tax
              
              ralign(fdc_status_register)
wc_1          
              lda     fdc_status_register
              lsr
              bcs     wc_1
              
              txa
              ldx     #3
wc_2          
              dex
              bne     wc_2
              tax
              
              rts

              
; ============================================================================

; ----------------------------------------------------------------------------
drv_tab:      byt     $00, $20, $40, $60
drv_msg:      byt     $0d, $0a, "Recalibrate drive? "
flags_save:   byt     0
